(* Startovni cislo 20 *)
program Zapalky;

uses Crt,Graph,Dos;

var
Reg:Registers; (* Pro praci s mysi *)
Prodleva,Gd,Gm,A,B,C,BestA,BestB,BestC:Integer; (* Cykly, pozice *)
MysX,MysY,Tlacitka:Word;
ZaMysi:array[-5..5,-5..5]of Byte;
Cara:array[0..11,0..11,1..4]of Byte;
(* Souradnice X, souradnice Y, strana 1:^ 2:> 3:v 4:<*)
Kl:Char;
Zvednuto:Boolean; (* Pusteno tl. mysi *)
Rezim,Velikost,HrajiciHrac,X,Y:Byte;
SkoreStr:string[10]; (* Pomocne prom. *)
Jmeno:array[1..2]of string[20];
Skore:array[1..2]of Integer;
Top10File:Text;
Top10:array[1..10]of record (* Pri spusteni naplni obsahem souboru Top10.dat *)
                       Jm:string[20];
                       Sk:Integer;
                     end;

(* Nastavi sour. mysi *)
procedure NastavSour(Horiz,Vert:Word);
begin
  Reg.ax:=4;
  Reg.cx:=Horiz;
  Reg.dx:=Vert;
  Intr($33,Reg);
end;

(* Zpracuje polozenou sirku *)
procedure UrciSkore(Smer:Byte);
var Konci:Boolean;
begin
  Konci:=True;
  for A:=1 to Velikost do
    for B:=1 to Velikost do
      for C:=1 to 4 do
        if Cara[A,B,C]=0 then Konci:=False;

  (* Vlastni ctverec *)
  if((Cara[X,Y,1]=HrajiciHrac)
  and(Cara[X,Y,2]=HrajiciHrac)
  and(Cara[X,Y,3]=HrajiciHrac)
  and(Cara[X,Y,4]=HrajiciHrac))
  then
    begin
      Skore[HrajiciHrac]:=Skore[HrajiciHrac]+1;
      SetFillStyle(1,HrajiciHrac+10);
      Bar(X*30,Y*30,X*30+30,Y*30+30);
      SetFillStyle(0,0);
    end;
  (* Okolni-vice bodu jednim tahem *)
  if(Smer=1)and((Cara[X,Y-1,1]=HrajiciHrac)
  and(Cara[X,Y-1,2]=HrajiciHrac)
  and(Cara[X,Y-1,3]=HrajiciHrac)
  and(Cara[X,Y-1,4]=HrajiciHrac))
  then
    begin
      Skore[HrajiciHrac]:=Skore[HrajiciHrac]+1;
      SetFillStyle(1,HrajiciHrac+10);
      Bar(X*30,(Y-1)*30,X*30+30,(Y-1)*30+30);
      SetFillStyle(0,0);
    end;

  if(Smer=3)and((Cara[X,Y+1,1]=HrajiciHrac)
  and(Cara[X,Y+1,2]=HrajiciHrac)
  and(Cara[X,Y+1,3]=HrajiciHrac)
  and(Cara[X,Y+1,4]=HrajiciHrac))
  then
    begin
      Skore[HrajiciHrac]:=Skore[HrajiciHrac]+1;
      SetFillStyle(1,HrajiciHrac+10);
      Bar(X*30,(Y+1)*30,X*30+30,(Y+1)*30+30);
      SetFillStyle(0,0);
    end;

  if(Smer=2)and((Cara[X+1,Y,1]=HrajiciHrac)
  and(Cara[X+1,Y,2]=HrajiciHrac)
  and(Cara[X+1,Y,3]=HrajiciHrac)
  and(Cara[X+1,Y,4]=HrajiciHrac))
  then
    begin
      Skore[HrajiciHrac]:=Skore[HrajiciHrac]+1;
      SetFillStyle(1,HrajiciHrac+10);
      Bar((X+1)*30,Y*30,(X+1)*30+30,Y*30+30);
      SetFillStyle(0,0);
    end;

  if(Smer=4)and((Cara[X-1,Y,1]=HrajiciHrac)
  and(Cara[X-1,Y,2]=HrajiciHrac)
  and(Cara[X-1,Y,3]=HrajiciHrac)
  and(Cara[X-1,Y,4]=HrajiciHrac))
  then
    begin
      Skore[HrajiciHrac]:=Skore[HrajiciHrac]+1;
      SetFillStyle(1,HrajiciHrac+10);
      Bar((X-1)*30,Y*30,(X-1)*30+30,Y*30+30);
      SetFillStyle(0,0);
    end;

  (* Vypis skore *)
  SetFillStyle(0,0);
  Bar(0,0,100,20);
  Str(Skore[1],SkoreStr);
  SetColor(11);
  if HrajiciHrac=2 then
    OutTextXY(1,1,Jmeno[1]+': '+SkoreStr+' <--')
  else
    OutTextXY(1,1,Jmeno[1]+': '+SkoreStr);
  SetColor(12);
  Str(Skore[2],SkoreStr);
  if HrajiciHrac=1 then
    OutTextXY(1,10,Jmeno[2]+': '+SkoreStr+' <--')
  else
    OutTextXY(1,10,Jmeno[2]+': '+SkoreStr);

  (* Dohrano *)
  if Konci then
    begin
      (* Top10 *)
      for A:=1 to 10 do
        if Skore[1]>Top10[A].Sk then
          begin
            for B:=10 downto A+1 do
              begin
                Top10[B].Jm:=Top10[B-1].Jm;
                Top10[B].Sk:=Top10[B-1].Sk;
              end;
            Top10[A].Jm:=Jmeno[1];
            Top10[A].Sk:=Skore[1];
            Break;
          end;
      for A:=1 to 10 do
        if Skore[2]>Top10[A].Sk then
          begin
            for B:=10 downto A+1 do
              begin
                Top10[B].Jm:=Top10[B-1].Jm;
                Top10[B].Sk:=Top10[B-1].Sk;
              end;
            Top10[A].Jm:=Jmeno[2];
            Top10[A].Sk:=Skore[2];
            Break;
          end;
      ReWrite(Top10File);
      for A:=1 to 10 do
        begin
          WriteLn(Top10File,Top10[A].Jm);
          WriteLn(Top10File,Top10[A].Sk);
        end;
      Close(Top10File);
      (* Oznameni *)
      SetColor(15);
      Str(Skore[1],SkoreStr);
      if Skore[1]>Skore[2] then OutTextXY(200,5,'KONEC - VYHRAL: '+Jmeno[1]+'('+SkoreStr+')');
      Str(Skore[2],SkoreStr);
      if Skore[1]<Skore[2] then OutTextXY(200,5,'KONEC - VYHRAL: '+Jmeno[2]+'('+SkoreStr+')');
      if Skore[1]=Skore[2] then OutTextXY(200,5,'KONEC - REMIZA');
      OutTextXY(200,20,'Stisknete ENTER...');

  Bar(400,30,639,450);
  for A:=1 to 10 do
    begin
      Str(Top10[A].Sk,SkoreStr);
      OutTextXY(400,10+20*A,Top10[A].Jm+': '+SkoreStr);
    end;

      ReadLn;
      Halt;
    end;
end;

procedure Help(var SourX,SourY,Strana:Integer);
(* Uzavira nacate ctverce, hra pocitace *)
var Souc,Best:Integer;
begin
  if((Rezim=2)and(HrajiciHrac=2))or(Rezim=3)then
    begin
      Bar(480,10,639,20);
      Str(Prodleva,SkoreStr);
      OutTextXY(480,10,'Prodleva(ms): '+SkoreStr);
      Delay(Prodleva);
    end;
  (* Porovnavej vyhodnost vsech moznosti *)
  Best:=0;
  for A:=1 to Velikost do
    for B:=1 to Velikost do
      for C:=1 to 4 do
        if Cara[A,B,C]=0 then
          begin
            Souc:=0;
            Cara[A,B,C]:=HrajiciHrac;
  (* Vlastni ctverec *)
  if((Cara[A,B,1]=HrajiciHrac)
  and(Cara[A,B,2]=HrajiciHrac)
  and(Cara[A,B,3]=HrajiciHrac)
  and(Cara[A,B,4]=HrajiciHrac))
  then
    Souc:=Souc+1;
  (* Okolni-vice bodu jednim tahem *)
  if(C=1)and((Cara[A,B-1,1]=HrajiciHrac)
  and(Cara[A,B-1,2]=HrajiciHrac)
  and(Cara[A,B-1,3]=HrajiciHrac)
  and(Cara[A,B-1,4]=HrajiciHrac))
  then
    Souc:=Souc+1;

  if(C=3)and((Cara[A,B+1,1]=HrajiciHrac)
  and(Cara[A,B+1,2]=HrajiciHrac)
  and(Cara[A,B+1,3]=HrajiciHrac)
  and(Cara[A,B+1,4]=HrajiciHrac))
  then
    Souc:=Souc+1;

  if(C=2)and((Cara[A+1,B,1]=HrajiciHrac)
  and(Cara[A+1,B,2]=HrajiciHrac)
  and(Cara[A+1,B,3]=HrajiciHrac)
  and(Cara[A+1,B,4]=HrajiciHrac))
  then
    Souc:=Souc+1;

  if(C=4)and((Cara[A-1,B,1]=HrajiciHrac)
  and(Cara[A-1,B,2]=HrajiciHrac)
  and(Cara[A-1,B,3]=HrajiciHrac)
  and(Cara[A-1,B,4]=HrajiciHrac))
  then
    Souc:=Souc+1;

  if Souc>Best then
    begin
      Best:=Souc;
      BestA:=A;
      BestB:=B;
      BestC:=C;
    end;
            Cara[A,B,C]:=0;
          end;
  (* pokud nevznikne zadny ctverec, nahodne umisti *)
  if Best=0 then
    repeat
      BestA:=Random(Velikost)+1;
      BestB:=Random(Velikost)+1;
      BestC:=Random(4)+1;
    until Cara[BestA,BestB,BestC]=0;

  (* Proved tah *)
  SetColor(HrajiciHrac+10);
  Cara[BestA,BestB,BestC]:=HrajiciHrac;
  if BestC=4 then
    Cara[BestA-1,BestB,2]:=HrajiciHrac;
  if BestC=2 then
    Cara[BestA+1,BestB,4]:=HrajiciHrac;
  if BestC=3 then
    Cara[BestA,BestB+1,1]:=HrajiciHrac;
  if BestC=1 then
    Cara[BestA,BestB-1,3]:=HrajiciHrac;

  if BestC=4 then
    Line(BestA*30,BestB*30,BestA*30,BestB*30+30);
  if BestC=2 then
    Line(BestA*30+30,BestB*30,BestA*30+30,BestB*30+30);
  if BestC=1 then
    Line(BestA*30,BestB*30,BestA*30+30,BestB*30);
  if BestC=3 then
    Line(BestA*30,BestB*30+30,BestA*30+30,BestB*30+30);
  X:=BestA;
  Y:=BestB;
  UrciSkore(BestC);
  HrajiciHrac:=HrajiciHrac+1;
  if HrajiciHrac=3 then HrajiciHrac:=1;
  SetColor(15);
end;

(* Cte stav mysi *)
procedure CtiStav(var Button,Horiz,Vert:Word);
begin
  Reg.ax:=3;
  Intr($33,Reg);
  Button:=Reg.bx;
  Horiz:=Reg.cx;
  Vert:=Reg.dx;
end;


(* ZACATEK PROGRAMU *)
begin
  Randomize;
  Rezim:=1;
  Prodleva:=200;
  Assign(Top10File,'Top10.dat');
  (* Otazky *)
  ClrScr;
  repeat
    Write('Zadejte rezim hry(1-hrac vs. hrac, 2-hrac vs. pocitac, 3-pocitac vs. pocitac): ');
    ReadLn(Rezim);
  until(Rezim>0)and(Rezim<4);
  Write('Zadejte jmeno prvniho hrace: ');
  ReadLn(Jmeno[1]);
  Write('Zadejte jmeno druheho hrace: ');
  ReadLn(Jmeno[2]);
  repeat
    Write('Zadejte velikost hraciho pole(2-10): ');
    ReadLn(Velikost);
  until(Velikost>1)and(Velikost<11);
  (* Grafika *)
  Gd:=Detect;
  InitGraph(Gd,Gm,'G:\20\');
  for A:=0 to Velikost do
    begin
      Line(A*30+30,30,A*30+30,Velikost*30+30);
      Line(30,A*30+30,Velikost*30+30,A*30+30);
    end;
  (* Ziskani pozadi kurzoru *)
  MysX:=30;
  MysY:=30;
  for A:=-5 to 5 do
    for B:=-5 to 5 do
      ZaMysi[A,B]:=GetPixel(MysX+A,MysY+B);
  HrajiciHrac:=2;
  UrciSkore(0);
  HrajiciHrac:=1;
  SetColor(15);
  OutTextXY(10,460,'Polozeni sirky - svisle: leve tl./ENTER      vodorovne: prave tl./SPACE');
  OutTextXY(10,470,'pohyb: mys/kurzorove klav.   help: H   rychlost pocitace: +/-   konec: Esc');
  (* Top 10 *)
  if FSearch('Top10.dat','')='' then
    begin
      ReWrite(Top10File);
      for A:=1 to 10 do
        begin
          WriteLn(Top10File,'NoName');
          WriteLn(Top10File,0);
        end;
      Close(Top10File);
    end;
  Reset(Top10File);
  for A:=1 to 10 do
    begin
      ReadLn(Top10File,Top10[A].Jm);
      ReadLn(Top10File,Top10[A].Sk);
    end;
  Close(Top10File);
  for A:=1 to 10 do
    begin
      Str(Top10[A].Sk,SkoreStr);
      OutTextXY(400,10+20*A,Top10[A].Jm+': '+SkoreStr);
    end;
  (* VLASTNI CYKLUS *)
  repeat
    (* Obnoveni pozadi kurzoru *)
    for A:=-5 to 5 do
      for B:=-5 to 5 do
        PutPixel(MysX+A,MysY+B,ZaMysi[A,B]);
    (* Pohyb klavesnici *)
    if KeyPressed then Kl:=ReadKey else Kl:=#0;
    if(Kl='+')and(Prodleva<2000)then Prodleva:=Prodleva+100;
    if(Kl='-')and(Prodleva>0)then Prodleva:=Prodleva-100;
    if(Kl=#72)and(Y>0)then
      begin
        NastavSour(MysX,MysY-10);
      end;
    if(Kl=#80)and(Y<Velikost+1)then
      begin
        NastavSour(MysX,MysY+10);
      end;
    if(Kl=#75)and(X>0)then
      begin
        NastavSour(MysX-10,MysY);
      end;
    if(Kl=#77)and(X<Velikost+1)then
      begin
        NastavSour(MysX+10,MysY);
      end;
    (* Napoveda *)
    if((Rezim=2)and(HrajiciHrac=2))or(Rezim=3)
    or(Kl='h')or(Kl='H')then Help(BestA,BestB,BestC);
    (* Poloha mysi *)
    CtiStav(Tlacitka,MysX,MysY);
    X:=MysX div 30;
    Y:=MysY div 30;
    (* Pokladani mysi a klavesnici *)
    if Tlacitka=0 then Zvednuto:=True;
    if((Tlacitka>0)or(Kl=' ')or(Kl=#13))and Zvednuto
    and((Rezim=1)or((Rezim=2)and(HrajiciHrac=1)))then
      begin
        Zvednuto:=False;
        SetColor(HrajiciHrac+10);
        (* Svisle *)
        if(Tlacitka=1)or(Kl=#13)then
          begin
            (* Vlevo *)
            if(MysX mod 30<15)and(Cara[X,Y,4]=0)and
            (X>0)and(X<Velikost+1)and(Y>0)and(Y<Velikost+1)then
              begin
                Cara[X,Y,4]:=HrajiciHrac;
                Cara[X-1,Y,2]:=HrajiciHrac;
                Line(X*30,Y*30,X*30,Y*30+30);
                UrciSkore(4);
                HrajiciHrac:=HrajiciHrac+1;
                if HrajiciHrac=3 then HrajiciHrac:=1;
              end;
            (* Vpravo *)
            if(MysX mod 30>14)and(Cara[X,Y,2]=0)and
            (X>0)and(X<Velikost+1)and(Y>0)and(Y<Velikost+1)then
              begin
                Cara[X,Y,2]:=HrajiciHrac;
                Cara[X+1,Y,4]:=HrajiciHrac;
                Line(X*30+30,Y*30,X*30+30,Y*30+30);
                UrciSkore(2);
                HrajiciHrac:=HrajiciHrac+1;
                if HrajiciHrac=3 then HrajiciHrac:=1;
              end;
          end;
        (* Vodorovne *)
        if(Tlacitka=2)or(Kl=' ')then
          begin
            (* Nahoru *)
            if(MysY mod 30<15)and(Cara[X,Y,1]=0)and
            (X>0)and(X<Velikost+1)and(Y>0)and(Y<Velikost+1)then
              begin
                Cara[X,Y,1]:=HrajiciHrac;
                Cara[X,Y-1,3]:=HrajiciHrac;
                Line(X*30,Y*30,X*30+30,Y*30);
                UrciSkore(1);
                HrajiciHrac:=HrajiciHrac+1;
                if HrajiciHrac=3 then HrajiciHrac:=1;
              end;
            (* Dolu *)
            if(MysY mod 30>14)and(Cara[X,Y,3]=0)and
            (X>0)and(X<Velikost+1)and(Y>0)and(Y<Velikost+1)then
              begin
                Cara[X,Y,3]:=HrajiciHrac;
                Cara[X,Y+1,1]:=HrajiciHrac;
                Line(X*30,Y*30+30,X*30+30,Y*30+30);
                UrciSkore(3);
                HrajiciHrac:=HrajiciHrac+1;
                if HrajiciHrac=3 then HrajiciHrac:=1;
              end;
          end;
        SetColor(15);
      end;

    (* Ziskani pozadi kurzoru *)
    for A:=-5 to 5 do
      for B:=-5 to 5 do
        ZaMysi[A,B]:=GetPixel(MysX+A,MysY+B);
    (* Kurzor *)
    Line(MysX,MysY-5,MysX,MysY+5);
    Line(MysX-5,MysY,MysX+5,MysY);
    Delay(50);
  until Kl=#27;(* Konec Escapem *)
end.